package com.sample;

import java.util.List;
import java.util.Properties;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.SystemEventListener;
import org.drools.SystemEventListenerFactory;
import org.drools.base.MapGlobalResolver;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.runtime.Environment;
import org.drools.runtime.EnvironmentName;
import org.drools.runtime.StatefulKnowledgeSession;
import org.jbpm.process.workitem.wsht.HornetQHTWorkItemHandler;
import org.jbpm.task.User;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.TaskClient;
import org.jbpm.task.service.TaskService;
import org.jbpm.task.service.TaskServiceSession;
import org.jbpm.task.service.hornetq.HornetQTaskClientConnector;
import org.jbpm.task.service.hornetq.HornetQTaskClientHandler;
import org.jbpm.task.service.hornetq.HornetQTaskServer;
import org.jbpm.test.JBPMHelper;
import org.jbpm.task.service.hornetq.AsyncHornetQTaskClient;
import org.jbpm.task.service.responsehandlers.BlockingTaskOperationResponseHandler;
import org.jbpm.task.service.responsehandlers.BlockingTaskSummaryResponseHandler;
import org.jbpm.task.service.SyncTaskServiceWrapper;
import bitronix.tm.TransactionManagerServices;

/**
 * This is a sample file to launch a process.
 */
public class ProcessMain {

	public static final void main(String[] args) throws Exception {
		startUp();
		startTaskService();
		// load up the knowledge base
		KnowledgeBase kbase = readKnowledgeBase();
		StatefulKnowledgeSession ksession = createKnowledgeSession(kbase);
		//JBPMHelper.registerTaskService(ksession);
		HornetQHTWorkItemHandler hornetQHTWorkItemHandler = new HornetQHTWorkItemHandler(ksession);
        ksession.getWorkItemManager().registerWorkItemHandler("Human Task", hornetQHTWorkItemHandler);
		// start a new process instance
		ksession.startProcess("com.sample.bpmn.hello");
		System.out.println("Process started ...");
		//System.out.println("Process started ...");
		
//		SystemEventListenerFactory.setSystemEventListener(new SystemEventListener());
//		//org.jbpm.task.TaskService taskClient = new SyncTaskServiceWrapper(new AsyncHornetQTaskClient("ProcessMain-testClient"));
//		TaskClient taskClient = new TaskClient(new HornetQTaskClientConnector("client 1", new HornetQTaskClientHandler(SystemEventListenerFactory.getSystemEventListener())));
//
//		taskClient.connect("127.0.0.1", 5445);
//
//
//		//Thread.sleep(1000);
//		
//		//getting a list of tasks
//		BlockingTaskSummaryResponseHandler taskSummaryResponseHandler = new BlockingTaskSummaryResponseHandler();
//		taskClient.getTasksAssignedAsPotentialOwner("john", "en-UK", taskSummaryResponseHandler);
//
//		List<TaskSummary> tasks = taskSummaryResponseHandler.getResults();
//		//TaskSummary task1 = taskClient.getTasksAssignedAsPotentialOwner("john", "en-UK").get(0);
//		//System.out.println("John executing task " + task1.getName() + "(" + task1.getId() + ": " + task1.getDescription() + ")");
//		//taskClient.start(task1.getId(), "john");
//		//taskClient.complete(task1.getId(), "john", null);
//		
//		//starting a task
//		BlockingTaskOperationResponseHandler responseHandler = new BlockingTaskOperationResponseHandler();
//        TaskSummary task = tasks.get(0);
//        Long taskId = task.getId();
//		taskClient.start( taskId, "john", responseHandler );
//		System.out.println("John has started");
//		responseHandler.waitTillDone(1000);
//		
//		//completing a task
//		responseHandler = new BlockingTaskOperationResponseHandler();
//		taskClient.complete( taskId, "john" , null, responseHandler );
//		System.out.println("John has completed");
//		responseHandler.waitTillDone(1000);
//		
//		taskSummaryResponseHandler = new BlockingTaskSummaryResponseHandler();
//		taskClient.getTasksAssignedAsPotentialOwner("mary", "en-UK", taskSummaryResponseHandler);
//        tasks = taskSummaryResponseHandler.getResults();
//		//starting a task
//		responseHandler = new BlockingTaskOperationResponseHandler();
//        task = tasks.get(0);
//        taskId = task.getId();
//		taskClient.start( taskId, "mary", responseHandler );
//		System.out.println("Mary has started");
//		responseHandler.waitTillDone(1000);
//		
//		//completing a task
//		responseHandler = new BlockingTaskOperationResponseHandler();
//		taskClient.complete( taskId, "mary" , null, responseHandler );
//		System.out.println("Mary has completed");
//		responseHandler.waitTillDone(1000);
		
 //		TaskSummary task2 = taskClient.getTasksAssignedAsPotentialOwner("mary", "en-UK").get(0);
 //		System.out.println("Mary executing task " + task2.getName() + "(" + task2.getId() + ": " + task2.getDescription() + ")");
 //		taskClient.claim(task1.getId(), "mary");
 //		taskClient.start(task2.getId(), "mary");
 //		taskClient.complete(task2.getId(), "mary", null);

//		taskClient.disconnect();
		hornetQHTWorkItemHandler.dispose();
		System.out.println("Ab to chal pad");
		System.exit(0);
	}

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("sample.bpmn"), ResourceType.BPMN2);
		return kbuilder.newKnowledgeBase();
	}
	
	private static void startUp() {
		Properties properties = JBPMHelper.getProperties();
		String driverClassName = properties.getProperty("persistence.datasource.driverClassName", "org.h2.Driver");
		if (driverClassName.startsWith("org.h2")) 
		{
     			System.out.println("H2 Server has started");
			 	JBPMHelper.startH2Server();
		}
		String persistenceEnabled = properties.getProperty("persistence.enabled", "false");
        String humanTaskEnabled = properties.getProperty("taskservice.enabled", "false");
		 if ("true".equals(persistenceEnabled) || "true".equals(humanTaskEnabled)) 
		 {
			    System.out.println("Persistence is enabled");
		 		JBPMHelper.setupDataSource();
		 }
		// please comment this line if you already have the task service running,
		// for example when running the jbpm-installer
		//JBPMHelper.startTaskService();
	}
	
	private static StatefulKnowledgeSession createKnowledgeSession(KnowledgeBase kbase)
	{
		EntityManagerFactory emf = null;
		emf = Persistence.createEntityManagerFactory ("org.jbpm.persistence.jpa");
		Environment env = KnowledgeBaseFactory.newEnvironment ();
 		env.set (EnvironmentName.ENTITY_MANAGER_FACTORY, emf);
 		env.set (EnvironmentName.GLOBALS, new MapGlobalResolver());
 		env.set (EnvironmentName.TRANSACTION_MANAGER,TransactionManagerServices.getTransactionManager ());
 		StatefulKnowledgeSession ksession = JPAKnowledgeService.newStatefulKnowledgeSession( kbase, null, env );
 		return ksession;
	}
	private static void startTaskService()
	{
		Properties properties = JBPMHelper.getProperties();
		String humanTaskEnabled = properties.getProperty("taskservice.enabled", "false");
		if ("true".equals(humanTaskEnabled))
		{
			System.out.println("HumanTask is enabled");
			EntityManagerFactory emf = null;
			emf = Persistence.createEntityManagerFactory ("org.jbpm.task");
	 		TaskService taskService = new TaskService(emf, SystemEventListenerFactory.getSystemEventListener());
		    HornetQTaskServer server = new HornetQTaskServer(taskService, 5445);
		    
//		    TaskServiceSession taskServiceSession = taskService.createSession();
//	        taskServiceSession.addUser(new User("john"));
//	        taskServiceSession.addUser(new User("mary"));
	 
	        Thread thread = new Thread(server);     
	        thread.start();     
	        System.out.println("Waiting for the HornetQTask Server to come up");     
	        while (!server.isRunning()) {         
	         System.out.print(".");         
	         try {
	          Thread.sleep( 50 );
	         } catch (InterruptedException e) {
	          e.printStackTrace();
	         } 
	        }
	       
		}
		
        }
    private static class SystemEventListener implements org.drools.SystemEventListener {

        public void debug(String arg0) {
        }

        public void debug(String arg0, Object arg1) {
        }

        public void exception(Throwable arg0) {
        }

        public void exception(String arg0, Throwable arg1) {
        }

        public void info(String arg0) {
        }

        public void info(String arg0, Object arg1) {
        }

        public void warning(String arg0) {
        }

        public void warning(String arg0, Object arg1) {
        }
    }

	
}